unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MTFind, ComCtrls, ToolWin, StdCtrls, Grids, Spin;

type
  TForm1 = class(TForm)
    Finder: TMTCompare;
    Label1: TLabel;
    EditFind: TEdit;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ButtonFind: TToolButton;
    ButtonClear: TToolButton;
    ToolButton3: TToolButton;
    ButtonExit: TToolButton;
    Label2: TLabel;
    MemoSearchIn: TMemo;
    GroupBox1: TGroupBox;
    StringGridResult: TStringGrid;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    Label5: TLabel;
    procedure OnFormCreate(Sender: TObject);
    procedure ButtonFindClick(Sender: TObject);
    procedure OnFinderFound(Sender: TObject; const S: String;
      FindQuality: Single);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
  private
    FCurGridIndex: Integer;
    procedure ParseLine(FromMemo: String; var S: TStringList);
    procedure FillGrid(S: String);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.OnFormCreate(Sender: TObject);
begin
  FCurGridIndex := 1;
  StringGridResult.Cells[0,0] := 'String';
  StringGridResult.Cells[1,0] := 'Quality (in %)';
  StringGridResult.RowCount := 2;
  SpinEdit1.Value := 60;
end;

procedure TForm1.FillGrid(S: String);
var
  I, J: Integer;
begin
  with StringGridResult do
    for I := 1 to RowCount-1 do
      for J := 0 to ColCount-1 do
        Cells[J,I] := S;
end;

procedure TForm1.ParseLine(FromMemo: String; var S: TStringList);
var
  Line: String;
  SLine: String;
  L, C: Integer;
begin
  Line := FromMemo;
  Line := Trim(Line);
  L := System.Length(Line);
  while L > 0 do
  begin
    C := System.Pos(' ', Line);
    if C > 0 then SLine := System.Copy(Line, 1, C) else SLine := Line;
    SLine := Trim(SLine);
    S.Add(SLine);
    System.Delete(Line, 1, C);
    if C > 0 then L := System.Length(Line) else L := 0;
  end;
end;

procedure TForm1.ButtonFindClick(Sender: TObject);
var
  I: Integer;
  SList: TStringList;
begin
  FillGrid('');
  StringGridResult.RowCount := 2;
  Finder.String1 := EditFind.Text;
  Finder.Quality := SpinEdit1.Value / 100;
  SList := TStringList.Create;
  for I := 0 to MemoSearchIn.Lines.Count-1 do
    ParseLine(MemoSearchIn.Lines[I], SList);
  Finder.Strings := SList;
  Finder.Run;
  SList.Free;
end;

procedure TForm1.OnFinderFound(Sender: TObject; const S: String;
  FindQuality: Single);
begin
  with StringGridResult do
  begin
    Cells[0, RowCount-1] := S;
    Cells[1, RowCount-1] := FloatToStr(FindQuality * 100);
    RowCount := RowCount + 1;
  end;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ButtonClearClick(Sender: TObject);
begin
  FillGrid('');
  StringGridResult.RowCount := 2;
  EditFind.Text := '';
  EditFind.SetFocus;
end;

end.
